#ifndef _COMMON_H__

#include <vector>
#include <string>
#include "bzfsAPI.h"

#define DEG_TO_RAD 0.0174532925f
#define RAD_TO_DEG 57.2957795f

class Point{
public:
	Point(float _x = 0, float _y = 0, float _z = 0);
	float x;
	float y;
	float z;
};

enum ObsticleType{
	eBox,
	eCylinder
};

class Box
{
public:
	Box(){ }
	Box(Point _position, Point _size, float _rotation);
	bool inside(Point pos, Point &newPos);

	ObsticleType type;
	Point position;
	Point size;
	float rotation;
};

class Cylinder
{
public:
	Cylinder(){ }
	Cylinder(Point _position, float _radius, float _height);
	bool inside(Point pos, Point &newPos);

	ObsticleType type;
	Point position;
	float radius;
	float height;
};

class Obsticle
{
public:
	Obsticle(){ }
	Obsticle(Box _box);
	Obsticle(Cylinder _cylinder);

	bool inside(Point pos, Point &newPos);
	ObsticleType type;
	Box box;
	Cylinder cylinder;
};

class Parser
{
public:
	static bool position(bz_APIStringList *nubs, Point &pos);
	static bool size(bz_APIStringList *nubs, Point &size);
	static bool rotation(bz_APIStringList *nubs, float &rotation);
	static bool radius(bz_APIStringList *nubs, float &radius);
	static bool height(bz_APIStringList *nubs, float &height);
};

float getAngle(float angle);
std::string getCallsign(int playerID);
bool isNumber(std::string str);
bool isNumber(bz_ApiString str);
void sendErrorMessage(std::string msg);
void sendWarningMessage(std::string msg);
void sendNoticeMessage(std::string msg);
void sendDebugMessage(std::string msg);

#define _COMMON_H__
#endif